#include <nSystem.h>

#define LOCK 0
#define UNLOCK 1
#define DESTROY 2

int count;
nTask coordinadorTask;

int coordinador() {
    nTask sender;

    int is_lock = 0;

    while(1) {
      int *msg = (int *)nReceive(&sender,-1);
      
      switch(*msg) {
      case LOCK:	
	if (!is_lock) {
	  is_lock = 1;
	  nReply(sender,0);
	}
	break;
      case UNLOCK:
	  is_lock = 0;
	  nReply(sender,0);
	break;
      case DESTROY:
	return(0);
	break;
      default:
	nPrintf("Esta raro\n");
      }
    }
}

int fib(int n)  {
  
  int msg = LOCK;
  nSend(coordinadorTask,(void *)&msg);
  count++;
  msg = UNLOCK;
  nSend(coordinadorTask,(void *)&msg);

  nPrintf("count=%d\n",count);

  if (n <= 1) return(1);

  else {
    nTask task1 = nEmitTask(fib,n-1);
    nTask task2 = nEmitTask(fib,n-2);

    int res = nWaitTask(task1)+nWaitTask(task2);
    
    return(res);
  }
}


int nMain(int argc, char *argv[]) {
  int x,y;
  count = 0;

  coordinadorTask = nEmitTask(coordinador);

  y = 6;
  x = fib(y);
  
  nWaitTask(coordinadorTask); 

  nPrintf("Fib(%d) = %d (%d procesos) \n",y,x,count);
}
